#!/usr/bin/env python
# Generator of random IDEA messages with the same format as generated by
# Dionaea connector.

from __future__ import print_function
import sys
from argparse import ArgumentParser
import re
import os
import os.path
import random
import base64
try:
    from urllib.parse import quote as url_quote # Py3
except ImportError:
    from urllib import quote as url_quote # Py2
from uuid import uuid4
from datetime import datetime, timedelta
from time import strftime, gmtime
import json

DEFAULT_NAME = 'org.example.test.dionaea'
DEFAULT_AWIN = 5 # aggregation window (minutes)
DEFAULT_TARGET_NET = '192.168.30.0/24'
DEFAULT_SOURCE_NET = '10.0.0.0/16'
DEFAULT_RATE = 20.0
DEFAULT_ATTACH_NAME = 'att1'

RE_CIDR = '^\d+\.\d+\.\d+\.\d+/\d+$'
RE_IP = '^\d+\.\d+\.\d+\.\d+$'
# TODO IPv6 support

# Names of AntiViruses on VirusTotal (for generating AV references)
AV_NAMES = "Ad-Aware;AegisLab;AhnLab-V3;ALYac;Antiy-AVL;Arcabit;Avast;AVG;Avira;AVware;Baidu;BitDefender;CAT-QuickHeal;ClamAV;CMC;Comodo;CrowdStrike;Cylance;Cyren;DrWeb;Emsisoft;Endgame;ESET-NOD32;F-Prot;F-Secure;GData;Ikarus;Sophos;Jiangmin;K7AntiVirus;K7GW;Kaspersky;MAX;McAfee;McAfee-GW-Edition;Microsoft;eScan;NANO-Antivirus;nProtect;Palo;Panda;Qihoo-360;Rising;SentinelOne;Sophos;SUPERAntiSpyware;Symantec;Tencent;TheHacker;TotalDefense;TrendMicro;TrendMicro-HouseCall;VBA32;VIPRE;ViRobot;Webroot;Yandex;Zillya;ZoneAlarm;Zoner;Alibaba;Avast-Mobile;Fortinet;Kingsoft;Malwarebytes;Symantec;Trustlook;WhiteArmor".split(';')


def ipstr2int(ipstr):
    parts = list(map(int, ipstr.split('.')))
    assert len(parts) == 4, "IP address must have 4 octets"
    assert all(0 <= part <= 255 for part in parts), "some octet is outside the 0-255 range"
    return (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8) | parts[3]

def int2ipstr(ipint):
    return '.'.join(map(str, (ipint >> 24, (ipint >> 16) & 0xff, (ipint >> 8) & 0xff, ipint & 0xff)))

def randstr(length):
    # Return random string of given nelgth
    return ''.join([random.choice("abcdefghijklmnopqrstuvwxyz") for _ in range(length)])


class random_ip_generator:
    # Generates random IP addresses from given CIDR network
    # (it's implemented manually to avoid dependency on any nonstandard packages)
    def __init__(self, cidr):
        try:
            net, prefix_len = cidr.split('/')
            ipint = ipstr2int(net)
            prefix_len = int(prefix_len)
            assert 0 <= prefix_len <= 32, "prefix length must be integer between 0 and 32"
            mask = ~((1 << (32-prefix_len)) - 1) & 0xffffffff
            assert ipint & ~mask == 0, "host part contains non-zero bits"
        except Exception as e:
            raise ValueError("Invalid CIDR: " + str(e))
        self.ipint = ipint
        self.prefix_len = prefix_len
        # If singe IP address, redefine next() method
        if prefix_len == 32:
            self.next = lambda: net

    def next(self):
        return int2ipstr(self.ipint + random.getrandbits(32 - self.prefix_len))



parser = ArgumentParser(description="Generator of random IDEA messages with the same format as generated by Dionaea connector.")
parser.add_argument(metavar='TARGET_DIR', nargs='?', type=str, dest='dir',
                    help="Target directory to store the messages to (excluding 'incoming/' at the end). Print a message to stdout if not set.")
parser.add_argument('-c', metavar='CNT', dest='cnt', type=int, default=1,
                    help="Number of messages to generate (default: 1). Target directory must be set to allow more than one message.")
parser.add_argument('-n', '--name', metavar='NAME', type=str, default=DEFAULT_NAME,
                    help="Value of Node[0].Name field (default: '"+DEFAULT_NAME+"').")
parser.add_argument('-s', '--source', metavar='CIDR', type=str, default=DEFAULT_SOURCE_NET,
                    help="Network from which source addresses are generated (default: '"+DEFAULT_SOURCE_NET+"').")
parser.add_argument('-t', '--target', metavar='IP/CIDR', type=str, default=DEFAULT_TARGET_NET,
                    help="IP address or network set as Target. If network is used, Anonymised is set to True. If empty string, Target is not set (default: '"+DEFAULT_TARGET_NET+"').")
parser.add_argument('--test', action='store_true',
                    help='Add "Test" to Category.')
parser.add_argument('-T', '--time', metavar='YYYY-MM-DDTHH:MM:SS', type=str,
                    help="EventTime of the first event (default: current time).")
parser.add_argument('-r', '--rate', metavar='N', type=float, default=DEFAULT_RATE,
                    help="Average number of alerts per hour (default: '"+str(DEFAULT_RATE)+"').")
parser.add_argument('--no-binaries', dest='binaries', action='store_false', default=True,
                    help="Don't include samples of malware binaries.")



args = parser.parse_args()

# Check validity of arguments

if not args.dir and args.cnt > 1:
    print("ERROR: Target directory must be set to generate more than one message.", file=sys.stderr)
    sys.exit(1)

if args.dir and not os.path.isdir(args.dir):
    print("ERROR: Target path doesn't exist or isn't a directory.", file=sys.stderr)
    sys.exit(1)

if args.name.isdigit():
    print("ERROR: Name should't be a number (if you try to set the number of messages, use -c)", file=sys.stderr)
    sys.exit(1)

try:
    src_gen = random_ip_generator(args.source)
except ValueError as e:
    print("ERROR in Source spcification: " + str(e), file=sys.stderr)
    sys.exit(1)

if args.target != "":
    if re.match(RE_CIDR, args.target):
        anonymized = True
    elif re.match(RE_IP, args.target):
        anonymized = False
    else:
        print("ERROR: Target is not a valid IPv4 address nor CIDR network.", file=sys.stderr)
        sys.exit(1)

if args.time:
    try:
        starttime = datetime.strptime(args.time, "%Y-%m-%dT%H:%M:%S")
    except ValueError as e:
        print("ERROR: Invalid EventTime: ", str(e), file=sys.stderr)
        sys.exit(1)
else:
    starttime = datetime.now()

# Create temp/ and incoming/ subdirectories if not exist
if args.dir:
    temp_path = os.path.join(args.dir, "temp")
    if not os.path.exists(temp_path):
        os.mkdir(temp_path)
    inc_path = os.path.join(args.dir, "incoming")
    if not os.path.exists(inc_path):
        os.mkdir(inc_path)



# Generate IDEA messages
for i in range(args.cnt):
    # Generate changing parts of message
    
    # Round win_start_time to the size of AWIN (AWIN should not be more than hour)
    win_start_time = starttime.replace(minute = starttime.minute - (starttime.minute % DEFAULT_AWIN), second = 0)
    win_end_time = win_start_time + timedelta(minutes=DEFAULT_AWIN)
    detect_time = win_end_time + timedelta(seconds=random.randint(1,3))
    
    conn_count = int(random.expovariate(0.5) + 1.0)
    
    source = src_gen.next()
    
    service = random.choice(['mysql', 'mssql', 'httpd', 'smbd', 'pcap']) # TODO allow to set this by a parameter
    
    proto = ['tcp']
    if service in ['mysql', 'mssql']:
        proto.append(service)
    elif service in ['httpd', 'smbd']:
        proto.append(service[:-1])

    if service == 'pcap':
        category = ['Recon.Scanning']
        dst_port = [random.randint(1,65535)]
    else:
        category = ['Attempt.Exploit']
        dst_port = {
            'mysql': 3306,
            'mssql': 1433,
            'httpd': 80,
            'smbd': 445,
        }[service]

    src_port = random.randint(1025,65535)
    
    # Create message
    idea = {
        "Format": "IDEA0",
        "ID": str(uuid4()),
        "Category": category,
        "DetectTime": detect_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "WinStartTime": win_start_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "WinEndTime": win_end_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "ConnCount": conn_count,
        "Source": [{}],
        "Target": [{
            "Port": [dst_port],
            "Proto": proto
        }],
        "Node": [
            {
                "Name": args.name,
                "Type": ["Connection","Honeypot","Recon"],
                "SW": ["Dionaea"],
                "AggrWin": strftime("%H:%M:%S", gmtime(DEFAULT_AWIN*60))
            }
        ]
    }
    
    # Fill IP addresses
    af = "IP4" if not ':' in source else "IP6"
    idea['Source'][0][af] = [source]
    
    if args.target != "":
        if anonymized:
            idea['Target'][0]['Anonymised'] = True
            idea['Target'][0][af] = [args.target]
        else:
            idea['Target'][0][af] = [args.target]


    # smbd allows to save malware - generate an attachemnt with some ranodm data (simulate a malware sample)
    if service == 'smbd' and random.random() < 0.66: # 66% chance to include maware sample
        # Generate some random information about the sample
        filename = randstr(int(random.triangular(1,16,1)))
        hostname = random.choice((source, randstr(random.randint(1,8)) + '.evil.example.net'))
        download_url = 'http://' + hostname + '/' + filename
        md5hash = hex(random.getrandbits(128))[2:]
        
        idea['Category'].append('Malware')
        idea['Source'][0]['URL'] = [download_url]
        
        # Generate "Attach" part of IDEA
        refs = []
        attach = { 
            "Handle": DEFAULT_ATTACH_NAME,
            "FileName": [filename],
            "Type": ["Malware"],
            "Hash": ["md5:" + md5hash],
        }
        
        # VirusTotal link, if hash found on VirusTotal
        if random.random() < 0.75:
            refs.append('url:https://www.virustotal.com/file/' + md5hash + '/analysis/')
        
            # Antivirus references
            if random.random() < 0.75:
                for av in AV_NAMES:
                    if random.random() < 0.9: # each AV kwons the malware with 90% prob.
                        malware_id = randstr(int(random.triangular(5,48,16))) # random malware ID
                        refs.append('urn:' + av + ':' + malware_id)
          
        if refs:
            refs = [url_quote(ref, safe=':') for ref in refs] # TODO: "safe" should be "/:" -> fix it in the connector and then also here 
            refs = list(set(refs))
            attach['Ref'] = refs
        
        if args.binaries:
            # Generate a malware sample as a long random byte array
            size = int(random.triangular(512, 16384, 2048))
            attach['ContentType'] = 'application/octet-stream'
            attach['ContentEncoding'] = 'base64'
            attach['Size'] = size
            attach['Content'] = base64.b64encode(os.urandom(size)).decode('ascii')
    
        
        idea['Source'][0]['AttachHand'] = [DEFAULT_ATTACH_NAME]
        idea['Attach'] = [attach]

    if args.test:
        idea['Category'].append('Test')

    # Store the message
    if args.dir:
        # Write message to temp/ directory
        filename = idea['ID'] + ".idea"
        with open(os.path.join(temp_path, filename), "w") as f:
            json.dump(idea, f)
        # Atomically move it to incoming/ directory
        os.rename(os.path.join(temp_path, filename), os.path.join(inc_path, filename))
    else:
        # Print to stdout if directory is not given
        print(json.dumps(idea, indent=4))
    
    # Move time for the next message
    # (model it as Poisson process, i.e. exponentially distributed random delays with lambda = rate)
    starttime += timedelta(seconds=int(random.expovariate(args.rate)*3600))
